# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2018-03-22 17:56
from __future__ import unicode_literals

from django.db import migrations
from django.db.migrations import RunPython

def create_variable(apps, schema_editor):
    template_model = apps.get_model('customer', 'CommunicationEventType')
    variable_model = apps.get_model('customer', 'CommunicationEventTypeTestVariable')

    comm_event_types = [
        {
            'code': 'SUBSCRIPTION_FOR_DISCOUNT',
            'name': 'Подписка на скидку',
            'variables': [
                {
                    'code': 'product.url',
                    'description': 'ссылка на товар'
                },
            ]
        },
    ]

    for comm_event_type in comm_event_types:
        try:
            template = template_model.objects.get(code=comm_event_type['code'])
        except template_model.DoesNotExist:
            template = template_model.objects.create(
                name=comm_event_type['name'],
                code=comm_event_type['code']
            )
        for variable in comm_event_type['variables']:
            variable_model.objects.create(
                template=template,
                code=variable['code'],
                description=variable['description'],
            )


def remove_variable(apps, schema_editor):
    template_model = apps.get_model('customer', 'CommunicationEventType')
    variable_model = apps.get_model('customer', 'CommunicationEventTypeTestVariable')

    try:
        test_variable = variable_model.objects.filter(template__code='SUBSCRIPTION_FOR_DISCOUNT', code='product.url')
    except template_model.DoesNotExist:
        pass
    else:
        test_variable.delete()

class Migration(migrations.Migration):

    dependencies = [
        ('offer', '0039_auto_20180321_0328'),
    ]

    operations = [
        RunPython(create_variable, remove_variable)
    ]
